package me.captain.dnc;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerChangedWorldEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.getspout.spoutapi.player.SpoutPlayer;

/**
 * Contains functions for ensuring the player is named properly.
 * 
 * @author captainawesome7, itsatacoshop247, Daxiongmao87, Luke Zwekii,
 *         Sammy, SniperFodder
 * 
 */
public class DPL extends PlayerListener
{
	private DispNameChanger plugin;
	
	/**
	 * Constructs a new DispNameChange Player Listener.
	 * 
	 * @param plugin
	 *            the plugin that created this listener.
	 */
	public DPL(DispNameChanger plugin)
	{
		this.plugin = plugin;
	}
	
	@Override
	public void onPlayerRespawn(PlayerRespawnEvent event)
	{
		if(plugin.isSpoutEnabled())
		{
			Player p = event.getPlayer();
			
			String sDisplay = p.getDisplayName();
			
			plugin.getServer()
					.getScheduler()
					.scheduleSyncDelayedTask(plugin,
							new RenameTask(plugin, (SpoutPlayer) p, sDisplay), 1L);
		}
		
	}
	
	@Override
	public void onPlayerChangedWorld(PlayerChangedWorldEvent event)
	{
		if(plugin.isSpoutEnabled())
		{
			Player p = event.getPlayer();
			
			String sDisplay = p.getDisplayName();
			
			plugin.getServer()
					.getScheduler()
					.scheduleSyncDelayedTask(plugin,
							new RenameTask(plugin, (SpoutPlayer) p, sDisplay), 1L);
		}
	}
	
	@Override
	public void onPlayerJoin(PlayerJoinEvent event)
	{
		Player joinee = event.getPlayer();
		
		String jname = joinee.getName();
		
		String jdname = joinee.getDisplayName();
		
		DP pClass = (DP) this.plugin.getDatabase().find(DP.class).where()
				.ieq("PlayerName", jname).findUnique();
		
		if (pClass == null)
		{
			pClass = new DP();
			
			pClass.setDisplayName(jdname);
			
			pClass.setPlayerName(jname);
		}
		
		jdname = pClass.getDisplayName();
		
		jdname = jdname.replaceAll("(&([a-f0-9]))", "$2");
		
		event.setJoinMessage(ChatColor.YELLOW + jdname + " joined the game.");
		
		joinee.setDisplayName(jdname);
		
		if (plugin.isSpoutEnabled())
		{			
			SpoutPlayer spoutTarget = (SpoutPlayer) joinee;
			
			plugin.getServer()
					.getScheduler()
					.scheduleSyncDelayedTask(plugin,
							new RenameTask(plugin, spoutTarget, jdname), 1L);
		}
	}
	
	@Override
	public void onPlayerQuit(PlayerQuitEvent event)
	{
		Player leavee = event.getPlayer();
		
		String lname = leavee.getName();
		
		String ldname = leavee.getDisplayName();
		
		DP pClass = (DP) this.plugin.getDatabase().find(DP.class).where()
				.ieq("PlayerName", lname).findUnique();
		
		if (pClass == null)
		{
			pClass = new DP();
			
			pClass.setDisplayName(ldname);
			
			pClass.setPlayerName(lname);
		}
		else
		{
			pClass.setPlayerName(lname);
			
			pClass.setDisplayName(ldname);
		}
		
		plugin.getDatabase().save(pClass);
		
		event.setQuitMessage(ChatColor.YELLOW + ldname + " left the game.");
	}
}