package me.captain.dnc;

import java.util.TimerTask;

import org.getspout.spoutapi.player.SpoutPlayer;

/**
 * Used to ensure that the display name above a players head is shown
 * correctly. This is do to a bug in Spout.
 * 
 * @author captainawesome7, itsatacoshop247, Daxiongmao87, Luke Zwekii,
 *         Sammy, SniperFodder
 * 
 */
public class RenameTask extends TimerTask
{
	private SpoutPlayer spoutTarget;
	
	private DispNameChanger plugin;
	
	private String sName;
	
	/**
	 * Constructs a new RenameTask.
	 * 
	 * @param disp
	 *            the plugin that originally made this task.
	 * @param player
	 *            the target of the rename.
	 * @param newName
	 *            the new name.
	 */
	public RenameTask(DispNameChanger disp, SpoutPlayer player, String newName)
	{
		plugin = disp;
		
		spoutTarget = player;
		
		sName = newName;
	}
	
	@Override
	public void run()
	{
		plugin.getApperanceManager().setGlobalTitle(spoutTarget, sName);
	}
	
}
